#include "game.h"

Game::Game(void)
{
}

Game::Game(int ID, Team* team1, Team* team2, int result[2])
: ID(ID), team1(team1), team2(team2) {
	this->result.score[0] = result[0]; 
	this->result.score[1] = result[1];
}

Game::Game(int ID, Team* team1, Team* team2, int result[2], Game* leftChild, Game* rightChild)
: ID(ID), team1(team1), team2(team2), leftChild(leftChild), rightChild(rightChild) {
	this->result.score[0] = result[0]; 
	this->result.score[1] = result[1];
}

Game::Game(int ID, Team* team1, Team* team2, int result[2], QString date, QString descr)
: ID(ID), team1(team1), team2(team2), date(date), descr(descr) {
	this->result.score[0] = result[0]; 
	this->result.score[1] = result[1];
}
	

Game::~Game(void)
{
}

int Game::getID(void) const
{
	return ID;
}

void Game::setBracket(int y0, int dy, int ylink, int level, int dir, int dashOffset, QPen pen)
{
	bracket.y0 = y0;
	bracket.dy = dy;
	bracket.ylink = ylink;
	bracket.level = level;
	bracket.dir = dir;
	bracket.dashOffset = dashOffset;
	bracket.pen = pen;
}

void Game::setBracket(int y0, int dy, int ylink, int dashOffset)
{
	bracket.y0 = y0;
	bracket.dy = dy;
	bracket.ylink = ylink;
	bracket.dashOffset = dashOffset;
}

struct Game::Bracket Game::getBracket(void) const
{
	return bracket;
}

void Game::setTeams(Team* team1, Team* team2)
{
	this->team1 = team1;
	this->team2 = team2;
}

void Game::setTeam(int teamnum, Team* team)
{
	if (teamnum==1)
		team1 = team;
	else
		team2 = team;
}

Team* Game::getTeam(int teamnum) const 
{
	if (teamnum==1)
		return team1;
	else
		return team2;
}


QString Game::getDate(void)  
{
	return date;
}

QString Game::getDescr(void)  
{
	return descr;
}

struct Game::Result Game::getResult(void) const
{
	return result;
}

void Game::setResult(int score[2])
{
	result.score[0] = score[0];
	result.score[1] = score[1];
}

int Game::getState(void) const
{
 	if(result.score[0]>result.score[1])
		return Game::WINTEAM1;
	else if(result.score[0]<result.score[1])
		return Game::WINTEAM2;
	else
		return Game::UNDECIDED;
}

void Game::setChilds(Game* leftChild, Game* rightChild)
{
	this->leftChild = leftChild;
	this->rightChild = rightChild;
}

Game* Game::getChild(int dir) const
{
	if(dir == Game::LEFTCHILD)
		return leftChild;
	else
		return rightChild;
}

bool Game::isChildGamesDecided(void)
{
	if(leftChild == Game::UNDEFINED)
		return true;
	else
	{
		if(leftChild->getState() != Game::UNDECIDED && rightChild->getState() != Game::UNDECIDED)
			return true;
		else
			return false;
	}
}

int Game::getTeam1(void)
{
	return team1->getId();
}

int Game::getTeam2(void)
{
	return team2->getId();
}

Team* Game::getTeam1Direct(void) 
{
	return team1;
}

Team* Game::getTeam2Direct(void) 
{
	return team2;
}

void Game::setPen(QPen pen)
{
	bracket.pen = pen;
}

void Game::setPenColor(int val)
{
	bracket.pen.setColor(QColor(val,val,val));
}