#include "team.h"

Team::Team(void)
:	name(QString("")), icon(QPixmap()) 
{
	id=-1;	//so we know, that this team is only a placeholder for games where we don't know the opponents yet
	this->setPick(Team::NO);
}

Team::Team(QString name, QString icon)
:	name(name), iconFile(icon), icon(QPixmap(icon)), lost(false) 
{
	id = Team::count;
	count++;
	this->setPick(Team::NO);
}

Team::Team(int id, QString name, QString info, QString icon)
:	id(id), name(name), iconFile(icon), icon(QPixmap(icon)), info(info), lost(false) {
	this->setPick(Team::NO);
}

Team::~Team(void)
{
}


int Team::count = 0; 

void Team::setName(QString name)
{
	this->name = name;
}

QString Team::getName(void)
{
	return name;
}

void Team::setIcon(QString iconFile)
{
	icon = QPixmap(iconFile);
}

void Team::setIconFile(QString filename){

	this->iconFile = filename;
	icon = QPixmap(iconFile);
}

QPixmap Team::getIcon(void)
{
	return icon;
}

QString Team::getIconFileName(void)
{
	return iconFile;
}

QString Team::getInfo(void)
{
	return info;
}

int Team::getId(void)
{
	return id;
}

Team::Round Team::getPick(void)
{
	return pick;
}

void Team::setPick(Team::Round r) 
{
	pick=r;
}

bool Team::hasLost(void)
{
	return lost;
}

void Team::setState(bool lost)
{
	this->lost = lost;
}

Team::Round Team::getPickForInt(int r)
{
	switch(r)
	{
		case 0: return NO;
		case 1: return SIXTEEN;
		case 2: return EIGHT;
		case 3: return QUARTER;
		case 4: return HALF;
		case 5: return FINAL;
		default: return NO;
	}
}