#include "xmlReader.h"

XmlReader::XmlReader()
{	
	 filename = "xml_examples/ebel2010.xml";
}

XmlReader::XmlReader(QString filename)
: filename(filename)
{	
}

Tournament* XmlReader::read (void)
{
	return this->read("");
}

Tournament* XmlReader::read(QString fileN)
{
	Tournament* tournament;

	if(fileN!="")
	{
		filename = fileN;
		qDebug("fileN!=");
	}

	QDomDocument doc( "Tournament" );
	QFile file( filename );
	if( !file.open( IO_ReadOnly ) ) {
		qDebug("IO_ReadOnly");
	}
	if( !doc.setContent( &file ) )
	{
	  file.close();
	}
	file.close();
	
	QDomElement root = doc.documentElement();
	if( root.tagName() != "tournament" )
	{
		throw 1;
		qDebug("Wrong XML file format");
	}
	
	QDomElement e = root.toElement();
	QString title = e.attribute("name","");
	qDebug(title.toLatin1());

	//firstC either teams or games
	QDomNode firstC = root.firstChild();
	QVector<int> ids;
	QVector<QString> names;
	QVector<QString> infos;
	QVector<QString> icons;
	QVector<int> picks;
	int counter = 0;

	//teams or games
	while( !firstC.isNull() )
	{
	  QDomElement e = firstC.toElement();
	  if( !e.isNull() )
	  {
		if( e.tagName() == "teams" )
		{
			//team (<team id="..">)
			QDomNode inner = e.firstChild();
			while(!inner.isNull())
			{
				QDomElement next = inner.toElement();
				if(!next.isNull()) {
					
					counter++;
					
					ids.append(next.attribute("id","").toInt());

					QDomNodeList nameList = next.elementsByTagName("name");
					QDomNodeList infoList = next.elementsByTagName("info");
					QDomNodeList iconList = next.elementsByTagName("icon");		
					QDomNodeList pickList = next.elementsByTagName("pick");
					
					for(int i=0; i<nameList.count(); i++) 
					{
						
						names.append(nameList.at(i).toElement().text());
						infos.append(infoList.at(i).toElement().text());
						icons.append(iconList.at(i).toElement().text());
						picks.append(pickList.at(i).toElement().text().toInt());

					}
				}				
				 inner = inner.nextSibling();
			}
			
			tournament = new Tournament(counter,title);
			QVector<Team*> teams = tournament->getTeams();

			for(int i=0; i<teams.size(); i++) 
			{
				teams[i]->setName(names.at(i));
				qDebug(icons.at(i).toLatin1());
				teams[i]->setIconFile(icons.at(i));
				teams[i]->setPick(Team::getPickForInt(picks.at(i)));
			}
			tournament->setTeams(teams);

		}

		ids.clear();
		QVector<int> teams1;
		QVector<int> teams2;
		QVector<int> results1;
		QVector<int> results2;
		QVector<QString> dates;
		QVector<QString> descr;

		if(e.tagName() == "games")
		{
			QDomNode inner = e.firstChild();
			while(!inner.isNull())
			{
				QDomElement next = inner.toElement();
				if(!next.isNull()) {
								
					ids.append(next.attribute("id","").toInt());
					QDomNodeList team1List = next.elementsByTagName("team1");
					QDomNodeList team2List = next.elementsByTagName("team2");
					QDomNodeList resultList = next.elementsByTagName("result");
					QDomNodeList dateList = next.elementsByTagName("date");	
					QDomNodeList descrList = next.elementsByTagName("descr");
					
					for(int i=0; i<team1List.count(); i++) 
					{
						
						teams1.append(team1List.at(i).toElement().text().toInt());
						teams2.append(team2List.at(i).toElement().text().toInt());
						QString temp = resultList.at(i).toElement().text();
						results1.append(temp.split(":").at(0).toInt());
						results2.append(temp.split(":").at(1).toInt());
						dates.append(dateList.at(i).toElement().text());
						descr.append(descrList.at(i).toElement().text());

					}
				}

				 inner = inner.nextSibling();
			}
			
			QVector<Team*> teams = tournament->getTeams();
			Game* game;
			Team* t1;
			Team* t2;
			
			for(int i=0; i<teams1.size(); i++) 
			{
				game = tournament->getGameByID(ids[i]);
				for(int j=0; j<teams.size(); j++) 
				{
					if(teams[j]->getId()==teams1.at(i)) {
						t1 = teams.at(j);
					}
					if(teams[j]->getId()==teams2.at(i)) t2 = teams.at(j);
				}
				game->setTeam(1, t1);
				game->setTeam(2, t2);

				int result[2];
				result[0]=results1.at(i);
				result[1]=results2.at(i);

				game->setResult(result);
				
			}
		}	

	  }

	  firstC = firstC.nextSibling();
	}
	return tournament;
}