#ifndef XMLREADER_H
#define XMLREADER_H
#define IO_ReadOnly QIODevice::ReadOnly


#include <QString>
#include <QDomElement>
#include <QFile>
#include <QDomDocument>

#include "tournament.h"

using namespace std;


/**
* @class XmlReader
*
* @brief Reads the infos of a tournament of a xml file.
*
* XmlReader opens a xml file, reads the data and stores it
* into a tournament object. 
* The xml file has to have this structure:

<tournament>	
	<teams>
		<team id="1">
			<name>Teamname</name>
			<info>Additional Information</info>
			<icon>relativeFilename.jpg</icon>
			<pick>0<pick>
		</team>
	</teams>	
  
	<games>
		<game id="6">
			<team1>1</team1>
			<team2>2</team2>
			<result>0:0</result>
			<date>2008-06-24 17:00</date>
			<descr>Additional Game Information</descr>
		</game>
		
	</games>
</tournament>

Remember: the game IDs have to be in reversed order (final game has highest number, etc.).

*/ 
class XmlReader
{
public:
	XmlReader();
	XmlReader(QString filename);

	/**
	* Reads data from the file with name "filename".
	*/
	Tournament* read();

	/**
	* Reads data from the file with name "fileN".
	*/
	Tournament* read(QString fileN);

private:
	QString filename;
};

#endif // CANVAS_H