#ifndef XMLWRITER_H
#define XMLWRITER_H
#define IO_ReadWrite QIODevice::ReadWrite


#include <QString>
#include <QDomElement>
#include <QFile>
#include <QDomDocument>
#include <QDomText>

#include "tournament.h"

using namespace std;


/**
* @class XmlWriter
*
* @brief Writes tournament infos to a file.
*
* Writes all information of a tournament object into a xml file.
*/ 
class XmlWriter
{
public:
	XmlWriter();

	/**
	* Creates a XmlWriter.
	* "filename" is the name of the file, where the data is written.
	*/
	XmlWriter(QString filename);

	/**
	* Writes the information of a tournament in the file 
	* with name "filename".
	*/
	bool write(Tournament* tournament);

private:
	QString filename;
};

#endif // XMLWRITER_H